#!/bin/sh

version=$(cat version)

packagemaker=/Developer/Applications/Utilities/PackageMaker.app/Contents/MacOS/PackageMaker
pkgName="sshfs-${version}.pkg"
dmgName="sshfs-${version}.dmg"

make clean build

# --------------------------------------------------
# http://developer.apple.com/documentation/Darwin/Conceptual/KEXTConcept/KEXTConceptPackaging/packaging_kext.html
echo "Copy Files"

sudo rm -rf pkgroot
sudo mkdir -p pkgroot/bin

sudo cp src/sshfs/build/Release/mount_sshfs pkgroot/bin
sudo cp -R src/sshfs/build/Release/urdfs.kext pkgroot/
sudo cp version pkgroot

sudo find pkgroot -type d | xargs sudo chmod 755
sudo find pkgroot -type f | xargs sudo chmod 644
sudo chmod 755 pkgroot/bin/*

sudo chown -R root:wheel pkgroot

# --------------------------------------------------
echo "Exec PackageMaker"

sudo $packagemaker -build \
    -p $pkgName \
    -f pkgroot \
    -ds \
    -i pkginfo/Info.plist \
    -d pkginfo/Description.plist

# --------------------------------------------------
echo "Make DiskImage"

sudo rm -f $dmgName
sudo rm -rf diskimage
sudo mkdir -p diskimage
sudo mv $pkgName diskimage
sudo chown -R root:wheel diskimage
sudo hdiutil create -srcfolder diskimage -volname sshfs $dmgName
