#ifndef URDFS_KEXT_NODE_HPP
#define URDFS_KEXT_NODE_HPP

#include <sys/vnode.h>

namespace URDFS {
  struct Node
  {
    LIST_ENTRY(URDFS::Node) hash;
    ino_t ino;
    struct mount *mountp;
    vnode_t parent;
    vnode_t vnode;
    vnode_t cacheVnode;
    struct timespec atime;
    struct timespec mtime;
    struct timespec ctime;
    off_t filesize;
    u_int32_t status;
    u_int32_t opencount;
  };

  inline Node *vnode2fsnode(vnode_t vp) { return reinterpret_cast<Node *>(vnode_fsnode(vp)); }

  namespace NodeHash {
    void initialize(void);
    void terminate(void);
    void add(Node *node);
    void remove(Node *node);
    vnode_t find(struct mount *mp, ino_t ino);
  };
};

#endif
