#ifndef URDFS_HPP
#define URDFS_HPP

#include "urdfs_bridge.hpp"
#include <sys/types.h>
#include <sys/param.h>
#include <errno.h>
#include <iostream>

inline void
START_MARKER(const char *name) {
#ifdef DEBUG
  std::cerr << "[BEGIN] " << name << "\n";
#else
#pragma unused(name)
#endif
}

inline int
RETURN(int error, const char *name) {
#ifdef DEBUG
  std::cerr << "[RETURN] [error = " << error << "] " << name << "\n";
#else
#pragma unused(error, name)
#endif
  return error;
}

#endif
