#ifndef URDFS_OP_HPP
#define URDFS_OP_HPP

#include <sys/dirent.h>
#include "urdfs_node.hpp"

namespace URDFS {
  class Operator {
  public:
    virtual ~Operator(void) {}

    virtual int create(const std::string &path) = 0;
    virtual int open(const URDFS::NodeEntry &node, bool writeAccess, bool trunc) = 0;
    virtual int getattr(struct stat *st, const std::string &path) = 0;
    virtual int setattr(const struct stat &st, const std::string &path) = 0;
    virtual int fsync(const std::string &path, const std::string &cacheFilePath) = 0;
    virtual int mkdir(const std::string &path) = 0;
    virtual int rmdir(const std::string &path) = 0;
    virtual int rename(const std::string &newpath, const std::string &oldpath) = 0;
    virtual int remove(const std::string &path) = 0;
    virtual int statfs(struct vfsstatfs *statfs) = 0;
    // ent can be NULL.
    virtual int readdir(struct dirent **ent, int *entnum, URDFS::NodeEntry *node) = 0;
    virtual int readlink(std::string *referred, const std::string &path) = 0;
    virtual int symlink(const std::string &path, const std::string &target) = 0;
  };
}

#endif
