#include "urdfs_thread.hpp"

URDFS::Thread::Mutex::Mutex(void)
{
  pthread_mutex_init(&mutex, NULL);
}

bool
URDFS::Thread::Mutex::lock(void)
{
  return pthread_mutex_lock(&mutex) == 0;
}

bool
URDFS::Thread::Mutex::unlock(void)
{
  return pthread_mutex_unlock(&mutex) == 0;
}

URDFS::Thread::Cond::Cond(void)
{
  pthread_cond_init(&cond, NULL);
}

bool
URDFS::Thread::Cond::wait(URDFS::Thread::Mutex *mutex)
{
  return pthread_cond_wait(&cond, mutex->getRaw()) == 0;
}

bool
URDFS::Thread::Cond::signal(void)
{
  return pthread_cond_signal(&cond);
}
