#ifndef LOCK_HPP
#define LOCK_HPP

#include <pthread.h>

namespace URDFS {
  namespace Thread {
    class Mutex {
    public:
      Mutex(void);
      bool lock(void);
      bool unlock(void);
      pthread_mutex_t *getRaw(void) { return &mutex; };

    private:
      pthread_mutex_t mutex;
    };

    class Cond {
    public:
      Cond(void);
      bool wait(URDFS::Thread::Mutex *mutex);
      bool signal(void);

    private:
      pthread_cond_t cond;
    };
  }
}

#endif
